#!/usr/bin/env python
# Python script to be run in Moneydance to perform amazing feats of financial scripting

from com.infinitekind.moneydance.model import *
from com.infinitekind.util import *

from com.infinitekind.moneydance.model import CurrencyType
from com.infinitekind.moneydance.model.CurrencyType import Type
from com.infinitekind.moneydance.model import CurrencyUtil

import sys
import time

if moneydance_data == None:
    print "no data to scan"
    sys.exit(0)
    
def reset_relative_currencies():
    currencies = moneydance_data.getCurrencies()
    baseCurr = curr = currencies.getBaseType()
    print("base currency: %s" % (baseCurr))
    baseNeedsSync = False
    if not baseCurr.getDoubleParameter("rrate", 1.0) == 1.0:
      print(" base currency has non-identity rrate: "+baseCurr.getParameter("rrate", "null"))
      baseCurr.setParameter("rrate", 1.0)
      baseNeedsSync = True
    if not baseCurr.getDoubleParameter("rate", 1.0) == 1.0:
      print(" base currency has non-identity rate: "+baseCurr.getParameter("rate", "null"))
      baseCurr.setParameter("rate", 1.0)
      baseNeedsSync = True
    if baseNeedsSync:
      baseCurr.syncItem()
    else:
      print("base currency has rate and rrate of 1.0.  That's good")
    
    baseSnapshots = baseCurr.getSnapshots()
    if baseSnapshots.size() > 0:
        print("ERROR: base currency has %s historical prices!"%(baseSnapshots.size()))
        for baseSnapshot in baseSnapshots:
            print("  deleting: %s"%(baseSnapshot))
            baseSnapshot.deleteItem()
    else:
        print("Base currency has no historical prices. That's good")
    
    
    root = moneydance_data.getRootAccount()
    root.setCurrencyType(baseCurr)
    root.syncItem()
    for curr in currencies:
        if curr.getCurrencyType() == CurrencyType.Type.SECURITY: continue
        print("\n\nChecking currency: %s" % (curr))
        curr.setParameter("relative_to_currid", None)
        curr.syncItem()
        print("  details: %s" % (curr.getSyncInfo().toMultilineHumanReadableString()))

reset_relative_currencies()
